Metadata
Retrieve a List of Standards/Studies
This request returns a list of Standards/Studies and their versions within the system.
The resultant lists are grouped by the unique administered ID aid for the Standard/Study.
GET {baseUrl}/fws/api/repository/containerExample response:
[
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"versions": [
{
"version": 0,
"label": "",
"name": "",
"identifier": "",
"versionLabel": "",
"containerType": "STUDY",
"updated": "ccyymmddThhmmss.sssZ",
"status": "",
"category": "NOT_IN_USE"
},
...
]
},
...
]
containerType can be either a STUDY or STANDARD.
category can be : NOT_IN_USE, PRODUCTION, REJECTED, IN_REVIEW, IN_PROGRESS, DRAFT
Errors: See Common Errors
Retrieve Details for a Standard/Study
Return a detailed version of the Standard/Study, including the owner, updated time, and rule compliance along with other standard or study details.
GET {baseUrl}/fws/api/repository/container/containerAID/version{
"uuid": "e016fadb-bc81-4fe3-9ce3-feedcaeced24",
"aid": "e016fadb-bc81-4fe3-9ce3-feedcaeced24",
"updated": "20230523T192843.439Z",
"containerType": "STUDY",
"version": 1,
"versionLabel": "",
"label": "",
"name": "",
"identifier": "",
"therapeuticArea": [
""
],
"sponsor": "",
"program": "",
"protocolID": "",
"protocolName": "",
"protocolTitle": "",
"status": "Draft",
"category": "DRAFT",
"owner": "",
"ruleCompliance": {
"compliant": 0,
"deviation": 0,
"nonStandard": 0
},
"assetStatus": [
{
"category": "PRODUCTION",
"name": "Production",
"total": 20
}
]
}containerType can be either STUDY or STANDARD
assetStatus contains the total count of assets for each Lifecycle state.
category can be: NOT_IN_USE, PRODUCTION, REJECTED, IN_REVIEW, IN_PROGRESS, DRAFT
versionLabel, name, sponsor and program are optional
protocolID, protocolName and protocolTitle are for STUDY containers only
owner is the username of the user that created the container
HTTP Status | Error Code | Description |
|---|---|---|
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non-numeric value was specified as the version. |
Errors: See Common Errors
Create a Standard or Study
This request can be used to create a Standard or Study.
POST {baseUrl}/fws/api/repository/containerExample Request:
{
"containerType": "STUDY",
"versionLabel": "",
"label": "",
"name": "",
"identifier": "",
"description": [
{
"locale": "",
"text": ""
}, ...
],
"therapeuticArea": [
"", ...
],
"sponsor": "",
"program": "",
"protocolID": "",
"protocolName": "",
"protocolTitle": "",
"owner": ""
}
Request Parameters | Accepted Values |
|---|---|
containerType | [Mandatory] STANDARD, STUDY |
versionLabel | [Optional] |
label | [Mandatory] |
name | [Optional] |
identifier | [Mandatory] |
Description | [Optional] |
therapeuticArea | [Optional] |
sponsor | [Optional] |
program | [Optional] |
protocolID | [Optional] |
protocolName | [Optional] |
protocolTitle | [Optional] |
owner | [Mandatory] UUID of the user to be specified as the owner |
containerType can be either STANDARD or STUDY.
protocolID, protocolName and protocolTitle are properties for Studies. If added to a request to create a Standard, they are ignored.
owner is used to assign a user ownership of the standard/study. This allows the user to make changes in the application. You can use the List Users request to find the UUID of the user to be set as the owner.
Example response:
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"version": 0
}
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_type | Unrecognized containerType provided. |
400 | value_cannot_be_empty | Empty label or identifier provided. |
404 | unknown_user | User specified as owner does not exist |
See also Common Errors
Retrieve a List of Asset Groups for a Standard/Study
Replace containerAID and version with your values.
GET {baseUrl}/fws/api/repository/container/containerAID/version/assetgroupThis request returns a list of Asset Groups within a Standard/Study in the system.
You should get a list of Standards/Studies and their versions beforehand. Then choose the appropriate one to use in this request.
A summary of rule compliance is returned for each Asset Group.
assetStatus contains the total count of assets for each lifecycle state.
category can be: NOT_IN_USE, PRODUCTION, REJECTED, IN_REVIEW, IN_PROGRESS, DRAFT
List of possible Asset Group types:
- ADaM
- SDTM
- SEND
- DATA ACQUISITION
- SOURCE DATASET (i.e. DATA)
- DATASET
You can use containerAID and version to specify which Standard/Study to retrieve the Asset Groups for.
Example response:
[
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"label": "",
"name": "",
"identifier": "",
"updated": "ccyymmddThhmmss.sssZ",
"assetGroupType": "DATASET",
"ruleCompliance": {
"compliant": 0,
"deviation": 0,
"nonStandard": 0
},
"assetStatus": [
{
"category": "",
"name": "",
"total": 0
},
...
]
},
...
]
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non-numeric value was specified as the version. |
404 | unknown_container | Unknown containerAID/version pair. |
See also Common Errors
Create an Asset Group
Add a new Asset Group to an existing standard or study. You can use containerAID and version to specify the standard/study to add the Asset Group to.
Replace containerAID and version with your values.
POST {baseUrl}/fws/api/repository/container/containerAID/version/assetgroupExample Request:
{
"assetGroupType": "SDTM",
"label": "",
"name": "",
"identifier": "",
"standardName": "",
"standardVersion": "",
"forSubmission": true
}
Request Parameters | Accepted Values |
|---|---|
assetGroupType | DATA_ACQUISITION, SDTM, SEND, ADAM, DATASET, GENERIC |
name, standardName, standardVersion and forSubmission are optional fields.
The fields standardName, standardVersion and forSubmission are for Dataset Asset Group types only (DATASET, SDTM, SEND, ADAM). If these fields are supplied for another type of Asset Group, then an error is returned.
Example response:
{
"aid": "01234567-89ab-cdef-0123-456789abcdef"
}
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_assetgroup_type | Unrecognized assetGroupType supplied. |
400 | incompatible_property | One of (standardName, standardVersion, forSubmission) have been supplied for a non-Dataset Asset Group. |
400 | invalid_workflow_state | Container is in a non-editable state. |
400 | value_cannot_be_empty | Empty label or identifier provided. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non-numeric value was specified as the version. |
404 | unknown_container | Unknown containerAID/version pair. |
See also Common Errors
Retrieve a List of Assets for an Asset Group in a Standard/Study
Replace containerAID, version, and assetgroupAID with your values.
GET {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/assetThis request returns a list of Assets within an Asset Group for a Standard/Study in the system. The response may be 'chunked' into partial results, depending on size.
The rule compliance type of each asset is returned.
assetStatus contains the total count of assets for each lifecycle state.
category can be: NOT_IN_USE, PRODUCTION, REJECTED, IN_REVIEW, IN_PROGRESS, DRAFT
Before making this request, you should first get a list of Standards/Studies and their versions, then get a list of Asset Groups for one Standard/Study.
You can use containerAID and version to specify the Standard/Study, and assetgroupAID to specify the Asset Group to retrieve the Assets for.
Example response:
[
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"label": "",
"name": "",
"identifier": "",
"updated": "ccyymmddThhmmss.sssZ",
"assetType": "DATASET",
"alias": [
{
"context": "",
"name": "",
"orderNumber": 0
}, ...
],
"description": [
{
"locale": "",
"text": "",
"orderNumber":0
}, ...
],
"therapeuticArea": [
"", ...
],
"clinicalStage": [
"", ...
],
"ruleCompliance": "COMPLIANCE",
"assetStatus": {
"name": "",
"category": ""
}
}, ...
]
The response returns a list of possible Assets and includes the assetType, For example: FORM, SECTION, QUESTION, TERM, METHOD, VARIABLE, COMMENT, etc.
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
404 | unknown_container | Unknown containerAID/version pair. |
404 | unknown_assetgroup | Unknown assetGroupAID within the containerAID/version pair. |
See also Common Errors
Retrieve a List of Assets for an Asset Group Filtered by Asset Type
GET {baseUrl}/fws/api/repository/container/containerAID/containerVersion/assetgroup/assetGroupAID/assetTypeReturn a list of Assets in an Asset Group which has been filtered by the specified Asset Type.
containerAID and containerVersion specify the Container in which the Asset Group exists.
assetGroupAID specifies the Asset Group being filtered.
The assetType can be VISIT, FORM, DATASET, TERMINOLOGY or FILE.
assetStatus contains the total count of assets for each lifecycle state. category can be: NOT_IN_USE, PRODUCTION, REJECTED, IN_REVIEW, IN_PROGRESS, DRAFT
[
{
"aid": "da742a14-9b6c-4e23-bf86-74ec29ec7da3",
"label": "",
"name": "”,
"identifier": "",
"updated": "20230101T010203.456Z",
"assetType": "FORM",
"alias": [
{
"context": "",
"name": "",
"orderNumber": 0
}, ...
],
"description": [
{
"locale": "",
"text": "",
"orderNumber": 0
}, ...
],
"therapeuticArea": [
"", ...
],
"clinicalStage": [
"", ...
],
"ruleCompliance": "NONSTANDARD",
"assetStatus": {
"name": "",
"category": ""
}
}, ...
]Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version |
400 | invalid_assetgroup_aid | An invalid AdministeredID was specified as the assetgroupAID. |
400 | asset_type_not_supported | Asset type not one of the following: VISIT, FORM, DATASET, TERMINOLOGY or FILE. |
404 | unknown_container | Could not find specified container using provided containerAID/version pair. |
404 | unknown_asset_group | Could not find specified asset group with provided assetGroupAID. |
See also Common Errors
Create an Asset
POST {baseUrl}/fws/api/repository/container/containerAID/version/assetReplace containerAID and version with your values.
When creating Assets, it is recommended that you start with the lowest level of referenced asset. For example, if you are creating a Section which references Questions; then you must create the Question assets first, either in the UI or by using the API. Similarly, if the Question assets reference a Terminology, then the Terminology must be created first.
It may be easier to create and manage lower level assets in ryze instead of creating them in the API.
Example Request:
{
"assetType": "SECTION",
"label": "Section Label",
"name": "Section Name",
"identifier": "S_1",
"description": [
{
"locale": "",
"text": "Section description"
},
{
"locale": "fr-FR",
"text": "Section French description"
}
],
"aliases": [
{
"context": "RAVE",
"name": "Section Rave Alias"
},
{
"context": "SDTM",
"name": "Section SDTM Alias"
}
],
"clinicalStage": [
"Study setup"
],
"therapeuticArea": [
"Devices",
"Hematology"
],
"repeating": true,
"repeat": {
"repeatType": "SIMPLE",
"simpleRepeats": 2,
"repeatQuestion": "{{questionAID}}",
"repeatsPerTerm": 1,
"otherQuestion": "{{questionAID}}",
"otherTerms": [
"{{termAID}}"
]
},
"questions": [
{
"aid": "{{questionAID}}",
"orderNumber": 5,
"mandatory": true,
"condition": "{{conditionAID}}",
"method": "{{methodAID}}"
}
]
}
Create an Asset within a standard/study. You can use containerAID and version to specify the container.
Example Response:
{
“aid”: “01234567-89ab-cdef-0123-456789abcdef”
}
Request Parameters | Accepted Values |
|---|---|
assetType | [Mandatory] VISIT_SCHEDULE, VISIT, FORM, SECTION, QUESTION, CONDITION, METHOD, UNIT, DATASET, VARIABLE, VALUE, SELECTION_CRITERIA, RESULT_DISPLAY, ANALYSIS_RESULT, TERMINOLOGY, TERM, COMMENT, FILE or LINK |
label | [Mandatory] |
name | [Optional] |
identifier | [Mandatory] |
clinicalStage | [Optional] |
therapeuticArea | [Optional] |
Description Properties | Description |
|---|---|
description | [Optional] |
locale | [Optional] |
text | [Optional] |
Aliases Properties | Description |
|---|---|
aliases | [Optional] |
context | [Optional] |
name | [Optional] |
orderNumber | [Optional] |
The following properties are applicable depending on the assetType and must be appended to the previous request. Properties are split by asset type and each asset type includes details of it's restrictions and optionality:
{
...
visits: [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"condition": "01234567-89ab-cdef-0123-456789abcdef"
}, ...
]
}Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | value_cannot_be_empty | Empty label or identifier provided. Or empty code provided for TERM asset. |
400 | invalid_class_type | classType provided for DATASET asset is not one of the required values. |
400 | invalid_comparator | comparator provided for QUESTION or SELECTION_CRITERIA asset is not one of the required values. |
400 | invalid_data_type | dataType provided for QUESTION, VARIABLE, VALUE, TERMINOLOGY or METHOD asset is not one of the required values. |
400 | invalid_order_number | A duplicate orderNumber has been included. |
400 | invalid_origin_type | originType provided for VARIABLE or VALUE asset is not one of the required values. |
400 | invalid_repeat_type | repeatType provided for SECTION asset is not one of the required values. |
400 | invalid_severity | severity provided for QUESTION asset is not one of the required values. |
400 | invalid_source | source provided for VARIABLE or VALUE asset is not one of the required values. |
400 | invalid_visit_type | visitType provided for VISIT asset is not one of the required values. |
400 | invalid_workflow_state | Container is not editable. |
400 | invalid_term_properties | externalDictionary and terms have both been provided for a TERMINOLOGY asset. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
404 | unknown_asset_referenced | An asset of this type with this aid cannot be found. Returned when an asset attempts to reference a child asset that does not exist, e.g. a FORM references a SECTION but a SECTION with that aid cannot be found. |
404 | unknown_container | Unknown containerAID/version pair |
See also Common Errors
Visit Schedule
Request Parameters | Description |
|---|---|
aid | The AID of an existing Visit. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
condition | [Optional] The AID of an existing Condition. |
Visit
{
...
repeating: true,
visitType: "SCHEDULED",
category: "",
forms: [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"condition": "01234567-89ab-cdef-0123-456789abcdef"
}, ...
]
}Request Parameters | Description |
|---|---|
repeating | [Optional] |
visitType | Must be SCHEDULED, UNSCHEDULED or COMMON |
category | [Optional] |
forms | [Optional] |
aid | The AID of an existing Form. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
condition | [Optional] The AID of an existing Condition. |
Form
{
...
"repeating": true,
"sections": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"condition": "01234567-89ab-cdef-0123-456789abcdef"
}, ...
]
}Request Parameters | Description |
|---|---|
aid | The AID of an existing Section. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
condition | [Optional] The AID of an existing Condition. |
Section
{
...
"repeating": true,
"repeat": {
"repeatType": "SIMPLE",
"simpleRepeats": 0,
"repeatQuestion": "01234567-89ab-cdef-0123-456789abcdef",
"repeatsPerTerm": 0,
"otherQuestion": "01234567-89ab-cdef-0123-456789abcdef",
"otherTerms": [
"01234567-89ab-cdef-0123-456789abcdef", ...
]
},
"questions": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"condition": "01234567-89ab-cdef-0123-456789abcdef",
"method": "01234567-89ab-cdef-0123-456789abcdef",
}, ...
]
}Request Parameters | Description |
|---|---|
repeating | [Optional] |
repeat | [Optional] |
Repeat Properties | Description |
|---|---|
repeatType | Must be SIMPLE or TERMINOLOGY |
simpleRepeats | [Optional] |
repeatQuestion | [Optional] AID of an existing Question. |
repeatsPerTerm | [Optional] |
otherQuestion | [Optional] AID of an existing Question. |
otherTerms | [Optional] A list of AIDs of existing Terms. |
Question Properties | Description |
|---|---|
questions | [Optional] |
category | [Optional] |
aid | The AID of an existing Question. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
condition | [Optional] The AID of an existing Condition. |
method | [Optional] The AID of an existing Method. |
Question
{
...
"dataType": "TEXT",
"question": [
{
"locale": "",
"text": ""
}, ...
],
"length": 0,
"fractionDigits": 0,
"submissionVariable": "",
"rangeChecks": [
{
"severity": "SOFT",
"comparator": "LT",
"values": [
{
"value": "",
"aid": "01234567-89ab-cdef-0123-456789abcdef"
}, ...
],
"formalExpressions": [
{
"context": "",
"expression": ""
}, ...
],
"errorMessage": [
{
"locale": "",
"text": ""
}, ...
]
}, ...
],
"terminology": "01234567-89ab-cdef-0123-456789abcdef",
"units": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0
}, ...
]
}
Request Parameters | Description |
|---|---|
dataType | Must be one of the following: TEXT, INTEGER, FLOAT, DATE, TIME, DATETIME, STRING, BOOLEAN, DOUBLE, HEXBINARY, BASE64BINARY, HEXFLOAT, BASE64FLOAT, PARTIALDATE, PARTIALTIME, PARTIALDATETIME, DURATIONDATETIME, INTERVALDATETIME, INCOMPLETEDATETIME, INCOMPLETEDATE, INCOMPLETETIME, URI |
question | [Optional] |
length | [Optional] |
fractionDigits | [Optional] |
submissionVariable | [Optional] |
terminology | [Optional] the AID of an existing Terminology |
rangeCheck Properties | Description |
|---|---|
rangeChecks | [Optional] |
severity | Must be SOFT or HARD |
comparator | LT, LE, GT, GE, EQ, NE, IN, NOTIN. |
unit | [Optional] the AID of an existing Unit |
values | [Optional] List of strings with aid as the AID of an existing Unit. |
formalExpressions | [Optional] |
errorMessage | [Optional] |
Unit Properties | Description |
|---|---|
units | [Optional] |
aid | The AID of an existing Unit. |
orderNumber | Should be unique in the list. |
{
...
"symbol": [
{
"locale": "",
"text": ""
}, ...
]
}Unit
Request Parameters | Description |
|---|---|
symbol | [Optional] |
Condition
{
...
"formalExpressions": [
{
"context": "",
"expression": ""
}, ...
]
}Request Parameters | Description |
|---|---|
formalExpressions | [Optional] |
Method
{
...
"dataType": "COMPUTATION",
"formalExpressions": [
{
"context": "",
"expression": ""
}, ...
]
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
}Request Parameters | Description |
|---|---|
formalExpressions | [Optional] |
dataType | Must be COMPUTATION, IMPUTATION, TRANSPOSE or OTHER |
documents | [Optional] |
Documents Properties | Description |
|---|---|
aid | The AID of an existing File. |
orderNumber | must be unique in the list. |
pageRef Properties | Description |
|---|---|
pageRef | [Optional] |
orderNumber | [Optional] must be unique in the list. |
pageNumber | [Optional] |
pageRange | [Optional] |
title | [Optional] |
destination | [Optional] |
Dataset
{
...,
"domain": "",
"class": {
"classType": "EVENTS",
"subclass": {
"subclass": "",
"subSubclass": {
"subclass": "",
"subSubclass": {...}
}
}
},
"repeating": true,
"structure": "",
"purpose": "",
"referenceData": true,
"location": "",
"comment": "01234567-89ab-cdef-0123-456789abcdef",
"variables": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"keySequence": 0,
"role": "",
"method": "01234567-89ab-cdef-0123-456789abcdef",
"hasNoData": "",
"nonStandard": ""
}
],
"hasNoData": ""
}Request Parameters | Description |
|---|---|
domain | [Optional] |
class | |
classType | Contains class type object. Must be one of: TRIAL_DESIGN, SPECIAL_PURPOSE, INTERVENTIONS, EVENTS, FINDINGS, FINDINGS_ABOUT, RELATIONSHIP, WILDCARD, SUBJECT_LEVEL_ANALYSIS_DATASET, ADVERSE_EVENT_ANALYSIS_DATASET, BASIC_DATA_STRUCTURE, ADAM_OTHER, STUDY_REFERENCE, OCCURRENCE_DATA_STRUCTURE, INTEGRATED_SUBJECT_LEVEL, INTEGRATED_BASIC_DATA_STRUCTURE, INTEGRATED_OCCURRENCE_DATA_STRUCTURE or NONE |
subClass | [Optional] recursive property for the class. subSubclass within subclass is optional. Example JSON snippets:
|
repeating | [Optional] [defaults to TRUE] |
structure | [Optional] |
purpose | [Optional] |
referenceData | [Optional] |
location | [Optional] |
comment | [Optional] |
variables | [Optional] |
Variables Properties | Description |
aid | The AID of an existing Variable. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
keySequence | [Optional] |
role | [Optional] |
method | [Optional] The AID of an existing Method. |
hasNoData | [Optional] [Boolean] Indicates that an Dataset has no records. Can be true or false. |
nonStandard | [Optional] [Boolean] Indicates that an Dataset has no records. Can be true or false. indicates that this Variable is not defined in the Implementation Guide standard referenced by the parent Dataset. |
Variable
{
...,
"dataType": "INTEGER",
"length": 0,
"fractionDigits": 0,
"displayFormat": "",
"originRefs": [
{
"orderNumber": 0,
"originType": "COLLECTED",
"source": "SUBJECT",
"description": "",
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
}, ...
],
"comment": "01234567-89ab-cdef-0123-456789abcdef",
"terminology": "01234567-89ab-cdef-0123-456789abcdef",
"values": [
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"keySequence": 0,
"role": "",
"method": "01234567-89ab-cdef-0123-456789abcdef",
"selectionCriterias": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true
}, ...
],
"hasNoData": ""
],
"coreCategory": "Global"
}Request Parameters | Description |
|---|---|
dataType | Must be TEXT, INTEGER, FLOAT, DATE, TIME, DATETIME, PARTIALDATE, PARTIALTIME, PARTIALDATETIME, DURATIONDATETIME, INTERVALDATETIME, INCOMPLETEDATETIME |
length | [Optional] |
fractionDigits | [Optional] |
displayFormat | [Optional] |
originRefs | [Optional] |
comment | [Optional] the AID of an existing Comment |
terminology | [Optional] the AID of an existing Terminology |
values | [Optional] |
coreCategory | [Optional] String that indicates whether an ADSL variable is a “Core” variable. Free text, for example “Global”, “Safety”, “Efficacy”. |
originRef Properties | Description |
originRefs | [Optional] |
orderNumber | Should be unique in the list. |
originType | Must be COLLECTED, DERIVED, ASSIGNED, PROTOCOL, PREDECESSOR, NOT_AVAILABLE |
source | [Optional] Must be SUBJECT, INVESTIGATOR, VENDOR, SPONSOR |
description | [Optional] |
documents | [Optional] |
Document Properties | Description |
aid | The AID of an existing File. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
keySequence | [Optional] Specifies if the property is mandatory |
role | [Optional] |
method | [Optional] the AID of an existing Method |
selectionCriterias | [Optional] |
hasNoData | [Optional] [Boolean] Indicates that the value has no data. Can be true or false. |
selctionCriterias Properties | Description |
aid | The AID of an existing Criteria. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
Value
{
...
"dataType": "FLOAT",
"length": 0,
"fractionDigits": 0,
"displayFormat": "",
"originRefs": [
{
"orderNumber": 0,
"originType": "DERIVED",
"source": "VENDOR",
"description": "",
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
}, ...
],
"comment": "01234567-89ab-cdef-0123-456789abcdef",
"terminology": "01234567-89ab-cdef-0123-456789abcdef"
}Request Parameters | Description |
|---|---|
dataType | Must be TEXT, INTEGER, FLOAT, DATE, TIME, DATETIME, PARTIALDATE, PARTIALTIME, PARTIALDATETIME, DURATIONDATETIME, INTERVALDATETIME, INCOMPLETEDATETIME |
length | [Optional] |
fractionDigits | [Optional] |
displayFormat | [Optional] |
originRefs | [Optional] |
comment | [Optional] the AID of an existing Comment |
terminology | [Optional] the AID of an existing Terminology |
originRef Properties | Description |
orderNumber | Should be unique in the list. |
originType | Must be COLLECTED, DERIVED, ASSIGNED, PROTOCOL, PREDECESSOR, NOT_AVAILABLE |
source | [Optional] Must be SUBJECT, INVESTIGATOR, VENDOR, SPONSOR |
description | [Optional] |
documents | [Optional] |
Document Properties | Description |
aid | The AID of an existing File. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
keySequence | [Optional] |
method | [Optional] the AID of an existing Method |
pageRef Properties | Description |
|---|---|
pageRef | [Optional] |
orderNumber | [Optional] must be unique in the list. |
pageNumber | [Optional] |
pageRange | [Optional] |
title | [Optional] |
destination | [Optional] |
Selection Criteria
{
...
"criteria": [
{
"variable": "01234567-89ab-cdef-0123-456789abcdef",
"comparator": "GT",
"values": [
"", ...
],
"terms": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"rank": 0.0
}, ...
]
}, ...
],
"comment": "01234567-89ab-cdef-0123-456789abcdef"
}Request Parameters | Description |
|---|---|
criteria | [Optional] |
comment | [Optional] The AID of an existing Comment |
Criteria Properties | Description |
variable | [Optional] |
comparator | [Optional] Must be one of LT, LE, GT, GE, EQ, NE, IN, NOTIN |
values | [Optional] |
terms | [Optional] |
Terms Properties | Description |
aid | The AID of an existing Term. |
orderNumber | Should be unique in the list. |
rank | [Optional] |
Result Display
{
...
"analysisResults": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0
}, ...
],
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
}Request Parameters | Description |
|---|---|
analysisResults | [Optional] |
analysisResults Properties | Description |
|---|---|
aid | The AID of an existing Term. |
orderNumber | Should be unique in the list. |
documents Properties | Description |
|---|---|
aid | The AID of an existing File. |
orderNumber | Should be unique in the list. |
pageRefs | [Optional] |
pageRef Properties | Description |
|---|---|
pageRef | [Optional] |
orderNumber | [Optional] must be unique in the list. |
pageNumber | [Optional] |
pageRange | [Optional] |
title | [Optional] |
destination | [Optional] |
Analysis Result
{
...
"analysisReason": "",
"analysisPurpose": "",
"parameter": "01234567-89ab-cdef-0123-456789abcdef",
"analysisDataset": {
"comment": "01234567-89ab-cdef-0123-456789abcdef",
"datasets": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"selectionCriteria": "01234567-89ab-cdef-0123-456789abcdef",
"variables": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"mandatory": true,
"keySequence": 0,
"role": "",
"method": "01234567-89ab-cdef-0123-456789abcdef"
}, ...
]
}, ...
]
},
"analysisDocumentation": {
"description": [
{
"locale": "",
"text": ""
}, ...
],
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
},
"analysisCode": {
"context": "",
"expression": "",
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
}
}Request Parameters | Description |
|---|---|
analysisReason | [Optional] |
analysisPurpose | [Optional] |
parameter | [Optional] The AID of an existing Variable. |
analysisDataset Properties | Description |
|---|---|
comment | [Optional] The AID of an existing Comment |
datasets Properties | Description |
|---|---|
aid | The AID of an existing Dataset. |
orderNumber | Should be unique in the list. |
selectionCriteria | [Optional] |
variables Properties | Description |
|---|---|
aid | The AID of an existing Variable. |
orderNumber | Should be unique in the list. |
mandatory | [Optional] Specifies if the property is mandatory |
keySequence | [Optional] |
role | [Optional] |
method | [Optional] AID of an existing Method |
analysisDocumentation Properties | Description |
|---|---|
description | [Optional] |
locale | [Optional] |
text | [Optional] |
documents | [Optional] |
documents Properties | Description |
|---|---|
aid | The AID of an existing File. |
orderNumber | Should be unique in the list. |
pageRef Properties | Description |
|---|---|
pageRef | [Optional] |
orderNumber | [Optional] must be unique in the list. |
pageNumber | [Optional] |
pageRange | [Optional] |
title | [Optional] |
destination | [Optional] |
analysisCode Properties | Description |
|---|---|
context | [Optional] |
expression | [Optional] |
description | [Optional] |
documents | [Optional] |
aid | The AID of an existing File. |
orderNumber | Should be unique in the list. |
pageRef | [Optional] |
Terminology
When creating a Terminology, terms and externalDictionary must not be sent in the same request.
Example with
{
...
"dataType": "STRING",
"comment": "01234567-89ab-cdef-0123-456789abcdef",
"terms": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"rank": 0.0
}
]
}Example with
{
...
"dataType": "STRING",
"externalDictionary": {
"name": "",
"version": "",
"localeReference": "",
"externalReference": ""
},
"comment": "01234567-89ab-cdef-0123-456789abcdef"
}Request Parameters | Description |
|---|---|
dataType | Must be TEXT, INTEGER, FLOAT, STRING |
comment | [Optional] The AID of an existing Comment |
externalDictionary | [Optional] |
terms | [Optional] |
orderNumber | Should be unique in the list. |
rank | [Optional] |
'
Term
{
...
"code": ""
"display": [
{
"locale": "",
"text": ""
}, ...
]
}Term assets ignore clinicalStage and therapeuticArea properties.
Request Parameters | Description |
|---|---|
display | [Optional] |
Comment
{
...
"comment": [
{
"locale": "",
"text": ""
}, ...
],
"documents": [
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"orderNumber": 0,
"pageRefs": [
{
"orderNumber": 0,
"pageNumber": "",
"pageRange": "",
"title": "",
"destination": [
"", ...
]
}, ...
]
}, ...
]
}Request Parameters | Description |
|---|---|
comment | [Optional] |
locale | [Optional] |
text | [Optional] |
documents Properties | Description |
|---|---|
aid | The AID of an existing File. |
orderNumber | Should be unique in the list. |
pageRef Properties | Description |
|---|---|
pageRef | [Optional] |
orderNumber | [Optional] must be unique in the list. |
pageNumber | [Optional] |
pageRange | [Optional] |
title | [Optional] |
destination | [Optional] |
File
A previously uploaded file does not need to be referenced and a File asset can be created without a file. In this case, ‘fileReferences’ is sent as an empty list and ‘entryPoint’ is omitted.
{
...
"fileReferences": [
{
"uuid": "01234567-89ab-cdef-0123-456789abcdef",
"path": ""
}, ...
],
"entryPoint": {
"uuid": "01234567-89ab-cdef-0123-456789abcdef",
"path": ""
},
"source": ""
}Request Parameters | Description |
|---|---|
fileReferences Properties | Description |
fileReferences | [Optional] |
uuid | The UUID of an existing staged file. |
path | uuid and path are returned from 'Add a temporary File' |
entryPoint Properties | Description |
|---|---|
entryPoint | [Optional] |
uuid | The UUID of an existing staged file. |
path | uuid and path are returned from 'Add a temporary File'. uuid and path should be one of the entries from ‘fileReferences’ |
source Properties | Description |
|---|---|
source | [Optional] |
A previously uploaded file does not need to be referenced and a File asset can be created without a file. In this case, ‘fileReferences’ is sent as an empty list and ‘entryPoint’ is omitted.
Link
{
...
"urlProtocol": "",
"urlBody": ""
}Request Parameters | Description |
|---|---|
urlProtocol | [Optional] |
urlBody | [Optional] |
Add an Asset to an Asset Group
PUT {baseUrl}/fws/api/repository/container/containerAID/containerVersion/assetgroup/assetgroupAID/asset/assetAIDThis request can be used to add an existing Asset to an Asset Group within a standard/study. The containerAID and version specify the standard/study, the assetGroupAID specifies the Asset Group to add to and assetAID specifies the Asset to add.
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_workflow_state | The container is not in an editable lifecycle state. |
400 | invalid_asset_type | The asset type is not valid for the asset group. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
400 | invalid_assetgroup_aid | An invalid AdministeredID was specified as the assetgroupAID. |
400 | invalid_asset_aid | An invalid AdministeredID was specified as the assetAID. |
404 | unknown_container | Unknown containerAID/version pair. |
404 | unknown_assetgroup | Unknown assetGroupAID within the containerAID/version pair. |
404 | unknown_asset | Unknown assetAID within the containerAID/version pair. |
See also Common Errors
Retrieve a List of Libraries for a Standard/Study
GET {baseUrl}/fws/api/repository/container/containerAID/version/librariesThis request returns a list of libraries for a standard/study in the system. containerAID and version specify the standard/study.
containerType can be either STANDARD or STUDY.
category : NOT_IN_USE, PRODUCTION, REJECTED, IN_REVIEW, IN_PROGRESS, DRAFT
Example response:
[
{
"aid": "01234567-89ab-cdef-0123-456789abcdef",
"containerType": "STANDARD",
"version": 0,
"versionLabel": "",
"label": "",
"name": "",
"identifier": "",
"status": "",
"category":"NOT_IN_USE"
}, ...
]
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
404 | unknown_container | Unknown containerAID/version pair. |
See also Common Errors
Associate a Library with a Standard/Study
PUT {baseUrl}/fws/api/repository/container/containerAID/version/libraries/libraryAID/libraryVersionThis request can be used to associate a library with a standard/study. containerAID and version specify the standard/study, and libraryAID and libraryVersion specify the library.
Example response:
{
}Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_type | A library cannot be added to a Standard that has been Published. |
400 | invalid_workflow_state | The library is not in a read-only workflow state. |
400 | cannot_create_already_exists | The specified library version is already associated with the container. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
400 | invalid_library_aid | An invalid AdministeredID was specified as the libraryAID. |
400 | invalid_library_version | A non numeric value was specified as the libraryVersion. |
404 | unknown_container | Unknown containerAID/version pair, or libraryAID/libraryVersion pair. |
See also Common Errors
Disassociate a Library with a Standard/Study
DELETE {baseUrl}/fws/api/repository/container/containerAID/version/libraries/libraryAID/libraryVersionThis request can be used to disassociate a library with a standard/study. containerAID and version specify the standard/study, and libraryAID and libraryVersion specify the library.
Example response:
{
}Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_type | A library cannot be added to a Standard that has been Published. |
400 | invalid_workflow_state | The library is not in a read-only workflow state. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
400 | invalid_library_aid | An invalid AdministeredID was specified as the libraryAID. |
400 | invalid_library_version | A non numeric value was specified as the libraryVersion. |
404 | unknown_container | Unknown containerAID/version pair, or libraryAID/libraryVersion pair. |
See also Common Errors
Import Assets from another Asset Group
PUT {baseUrl}/fws/api/repository/container/containerAID/containerVersion/library/importThis request can be used to import assets from another standard/study. The source standard/study must be associated as a Library. Imported assets include any associated child assets. containerAID and containerVersion specify the target standard/study for the imported asset. The source standard/study is specified in the request body.
Example Request:
{
"sourceContainer": "",
"sourceVersion": 0,
"targetAssetGroup": "",
"assets": [
"", ...
]
}Example response:
[
{
"sourceAID": "",
"targetAID": "",
}, ...
]
Parameters:
Request Parameters | Description |
|---|---|
sourceContainer | the AID of the standard/study to import assets from. |
sourceVersion | the version number of the standard/study to import assets from. |
targetAssetGroup | [Optional] is the AID of the asset group that the assets are to be imported to. If not set, the asset is imported into the standard/study containerAID specified in the request. |
assets | lists any asset AIDs to be imported |
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_workflow_state | Container is not editable. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
404 | unknown_container | Unknown containerAID/version pair. |
404 | unknown_source_container | Unknown sourceContainer AID/sourceVersion pair for source. |
See also Common Errors
Request the Generation of an ODM for an Asset Group (Deprecated)
Important: This endpoint is deprecated, use the async version instead: Request generation of an ODM for an Asset Group Asynchronously
This request can be used to generate and download the ODM / Define-XML project file for an Asset Group.
You can use the containerAID, version, and assetgroupAID to specify which Asset Group is generated.
A unique identifier for the download is returned. The unique identifier can then be used to request the download of the prepared file. The returned UUID should be used in the file retrieval call as the fileUUID. See Retrieve a previously prepared File
Replace containerAID, version, and assetgroupAID with your values.
GET {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/odmExample response:
{
"uuid": "01234567-89ab-cdef-0123-456789abcdef"
}Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_assetgroup_type | Asset groups of this type cannot have an ODM generated. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
400 | invalid_assetgroup_aid | An invalid AdministeredID was specified as the assetgroupAID. |
404 | unknown_container | Unknown containerAID/version pair. |
404 | unknown_assetgroup | Could not find specified assetgroupAID for given containerAID/version pair. |
See also Common Errors
Request generation of an ODM for an Asset Group Asynchronously
GET {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/odmAsyncRequest that the ODM/XML output file for the asset group specified by containerAID, version, and assetgroupAID to be made available for download.
A unique identifier for the future prepared download is returned, which can then be used to request download of the file. The returned UUID should be used in the file retrieval call as the fileUUID.
As the file UUID is prepared in advance of the execution being completed and the file being ready, requests for the file may return 404 responses until the execution is completed in the background.
Additionally, further requests for the same ODM generation may return a 409 response with the message already_queued until the execution is completed in the background.
Example Response:
Errors:
HTTP Status | Error Code |
|
|---|---|---|
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
400 | invalid_assetgroup_aid | An invalid AdministeredID was specified as the assetgroupAID. |
404 | invalid_assetgroup_type | Asset groups of this type cannot have an ODM generated. |
404 | unknown_container | Unknown containerAID/version pair. |
404 | unknown_assetgroup | Could not find specified assetgroupAID for given containerAID/version pair. |
409 | already_queued | The ODM generation is still in progress and cannot be queued again. |
500 | other | The ODM generation could not be started or the output file could not be prepared. |
See also Common Errors.
Upload the Asset Content of an ODM/Define into an Asset Group
PUT {baseUrl}/fws/api/repository/container/containerAID/version/assetgroup/assetgroupAID/odmRequest for the asset content of an ODM / Define-XML project file to be uploaded to the asset group specified by the containerAID, version and assetgroupAID.
On success, an empty OK response is returned and the asset content of the file is added to the specified asset group.
For Data Acquisition asset groups, the expected file format is ODM
For Dataset type asset groups, a Define-XML 2.0 file is expected.
Example Request:
MultipartFormData containing a valid ODM/Define XML file, for example:
Example Response:
Errors:
HTTP Status | Error Code | |
|---|---|---|
400 | invalid_assetgroup_type | Asset groups of this type cannot have an ODM or Define uploaded to them. |
400 | invalid_workflow_state | The container being uploaded to is in a non-editable state. |
400 | file_not_found | MultipartFormData does not include a file. |
400 | invalid_container_aid | An invalid AID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
400 | invalid_assetgroup_aid | An invalid AdministeredID was specified as the assetgroupAID. |
400 | other | Indicates a problem with the file or the plugin environment. |
See also Common Errors
Create a New Version of an Existing Container
PUT {baseUrl}/fws/api/repository/container/containerAID/version/versionCreate a new version of the specified container based on the version specified. On success, a JSON response is returned with the basic details of the new version of the container.
Example Response:
HTTP Status | Error Code | |
|---|---|---|
400 | invalid_workflow_state | The container being versioned already has a version in an editable state. |
400 | invalid_container_aid | An invalid AdministeredID was specified as the containerAID. |
400 | invalid_container_version | A non numeric value was specified as the version. |
404 | unknown_container | The container referred to by containerAID/version pair was not found. |
400 | invalid_container_type | This type of container cannot be versioned by users. |
